# autosde_openapi_client

OpenapiClient - the Ruby gem for the Site Manager API

Site Manager API

This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build autosde_openapi_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./autosde_openapi_client-1.0.0.gem
```

(for development, run `gem install --dev ./autosde_openapi_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'autosde_openapi_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'autosde_openapi_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:

```ruby
# Load the gem
require 'autosde_openapi_client'

# Setup authorization
OpenapiClient.configure do |config|
  # Configure Bearer authorization: bearerAuth
  config.access_token = 'YOUR_BEARER_TOKEN'
end

api_instance = OpenapiClient::AbstractCapabilityApi.new

begin
  result = api_instance.abstract_capabilities_get
  p result
rescue OpenapiClient::ApiError => e
  puts "Exception when calling AbstractCapabilityApi->abstract_capabilities_get: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:9000/site-manager/api/v1/engine*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OpenapiClient::AbstractCapabilityApi* | [**abstract_capabilities_get**](docs/AbstractCapabilityApi.md#abstract_capabilities_get) | **GET** /abstract-capabilities/ | 
*OpenapiClient::AbstractCapabilityApi* | [**abstract_capabilities_pk_delete**](docs/AbstractCapabilityApi.md#abstract_capabilities_pk_delete) | **DELETE** /abstract-capabilities/{pk}/ | 
*OpenapiClient::AbstractCapabilityApi* | [**abstract_capabilities_pk_get**](docs/AbstractCapabilityApi.md#abstract_capabilities_pk_get) | **GET** /abstract-capabilities/{pk}/ | 
*OpenapiClient::AbstractCapabilityApi* | [**abstract_capabilities_post**](docs/AbstractCapabilityApi.md#abstract_capabilities_post) | **POST** /abstract-capabilities/ | 
*OpenapiClient::AccountApi* | [**accounts_get**](docs/AccountApi.md#accounts_get) | **GET** /accounts/ | 
*OpenapiClient::AccountApi* | [**accounts_pk_delete**](docs/AccountApi.md#accounts_pk_delete) | **DELETE** /accounts/{pk} | 
*OpenapiClient::AccountApi* | [**accounts_pk_get**](docs/AccountApi.md#accounts_pk_get) | **GET** /accounts/{pk} | 
*OpenapiClient::AccountApi* | [**accounts_pk_put**](docs/AccountApi.md#accounts_pk_put) | **PUT** /accounts/{pk} | 
*OpenapiClient::AccountApi* | [**accounts_post**](docs/AccountApi.md#accounts_post) | **POST** /accounts/ | 
*OpenapiClient::AddressApi* | [**addresses_get**](docs/AddressApi.md#addresses_get) | **GET** /addresses/ | 
*OpenapiClient::AddressApi* | [**addresses_pk_delete**](docs/AddressApi.md#addresses_pk_delete) | **DELETE** /addresses/{pk} | 
*OpenapiClient::AddressApi* | [**addresses_pk_get**](docs/AddressApi.md#addresses_pk_get) | **GET** /addresses/{pk} | 
*OpenapiClient::AddressApi* | [**addresses_post**](docs/AddressApi.md#addresses_post) | **POST** /addresses/ | 
*OpenapiClient::AuthenticationApi* | [**token_auth_post**](docs/AuthenticationApi.md#token_auth_post) | **POST** /token-auth | 
*OpenapiClient::AutoSDEProjectApi* | [**autosde_projects_get**](docs/AutoSDEProjectApi.md#autosde_projects_get) | **GET** /autosde-projects/ | 
*OpenapiClient::AutoSDEProjectApi* | [**autosde_projects_pk_delete**](docs/AutoSDEProjectApi.md#autosde_projects_pk_delete) | **DELETE** /autosde-projects/{pk}/ | 
*OpenapiClient::AutoSDEProjectApi* | [**autosde_projects_pk_get**](docs/AutoSDEProjectApi.md#autosde_projects_pk_get) | **GET** /autosde-projects/{pk}/ | 
*OpenapiClient::AutoSDEProjectApi* | [**autosde_projects_post**](docs/AutoSDEProjectApi.md#autosde_projects_post) | **POST** /autosde-projects/ | 
*OpenapiClient::AutoSDERoleApi* | [**autosde_roles_get**](docs/AutoSDERoleApi.md#autosde_roles_get) | **GET** /autosde-roles/ | 
*OpenapiClient::AutoSDERoleApi* | [**autosde_roles_pk_delete**](docs/AutoSDERoleApi.md#autosde_roles_pk_delete) | **DELETE** /autosde-roles/{pk}/ | 
*OpenapiClient::AutoSDERoleApi* | [**autosde_roles_pk_get**](docs/AutoSDERoleApi.md#autosde_roles_pk_get) | **GET** /autosde-roles/{pk}/ | 
*OpenapiClient::AutoSDERoleApi* | [**autosde_roles_post**](docs/AutoSDERoleApi.md#autosde_roles_post) | **POST** /autosde-roles/ | 
*OpenapiClient::CapabilityTranslationApi* | [**capability_translations_get**](docs/CapabilityTranslationApi.md#capability_translations_get) | **GET** /capability-translations/ | 
*OpenapiClient::CapabilityTranslationApi* | [**capability_translations_pk_delete**](docs/CapabilityTranslationApi.md#capability_translations_pk_delete) | **DELETE** /capability-translations/{pk} | 
*OpenapiClient::CapabilityTranslationApi* | [**capability_translations_pk_get**](docs/CapabilityTranslationApi.md#capability_translations_pk_get) | **GET** /capability-translations/{pk} | 
*OpenapiClient::CapabilityTranslationApi* | [**capability_translations_post**](docs/CapabilityTranslationApi.md#capability_translations_post) | **POST** /capability-translations/ | 
*OpenapiClient::HostApi* | [**hosts_get**](docs/HostApi.md#hosts_get) | **GET** /hosts/ | 
*OpenapiClient::HostApi* | [**hosts_pk_delete**](docs/HostApi.md#hosts_pk_delete) | **DELETE** /hosts/{pk} | 
*OpenapiClient::HostApi* | [**hosts_pk_get**](docs/HostApi.md#hosts_pk_get) | **GET** /hosts/{pk} | 
*OpenapiClient::HostApi* | [**hosts_post**](docs/HostApi.md#hosts_post) | **POST** /hosts/ | 
*OpenapiClient::HostVolumeConnectionApi* | [**host_volume_connection_get**](docs/HostVolumeConnectionApi.md#host_volume_connection_get) | **GET** /host-volume-connection/ | 
*OpenapiClient::HostVolumeConnectionApi* | [**host_volume_connection_pk_delete**](docs/HostVolumeConnectionApi.md#host_volume_connection_pk_delete) | **DELETE** /host-volume-connection/{pk} | 
*OpenapiClient::HostVolumeConnectionApi* | [**host_volume_connection_pk_get**](docs/HostVolumeConnectionApi.md#host_volume_connection_pk_get) | **GET** /host-volume-connection/{pk} | 
*OpenapiClient::HostVolumeConnectionApi* | [**host_volume_connection_post**](docs/HostVolumeConnectionApi.md#host_volume_connection_post) | **POST** /host-volume-connection/ | 
*OpenapiClient::JobApi* | [**jobs_get**](docs/JobApi.md#jobs_get) | **GET** /jobs | 
*OpenapiClient::JobApi* | [**jobs_post**](docs/JobApi.md#jobs_post) | **POST** /jobs | 
*OpenapiClient::NativeCapabilityApi* | [**native_capabilities_get**](docs/NativeCapabilityApi.md#native_capabilities_get) | **GET** /native-capabilities/ | 
*OpenapiClient::NativeCapabilityApi* | [**native_capabilities_pk_delete**](docs/NativeCapabilityApi.md#native_capabilities_pk_delete) | **DELETE** /native-capabilities/{pk} | 
*OpenapiClient::NativeCapabilityApi* | [**native_capabilities_pk_get**](docs/NativeCapabilityApi.md#native_capabilities_pk_get) | **GET** /native-capabilities/{pk} | 
*OpenapiClient::NativeCapabilityApi* | [**native_capabilities_post**](docs/NativeCapabilityApi.md#native_capabilities_post) | **POST** /native-capabilities/ | 
*OpenapiClient::ProfileApi* | [**profiles_get**](docs/ProfileApi.md#profiles_get) | **GET** /profiles/ | 
*OpenapiClient::ProfileApi* | [**profiles_pk_delete**](docs/ProfileApi.md#profiles_pk_delete) | **DELETE** /profiles/{pk}/ | 
*OpenapiClient::ProfileApi* | [**profiles_pk_get**](docs/ProfileApi.md#profiles_pk_get) | **GET** /profiles/{pk}/ | 
*OpenapiClient::ProfileApi* | [**profiles_post**](docs/ProfileApi.md#profiles_post) | **POST** /profiles/ | 
*OpenapiClient::ProvisioningStrategyApi* | [**provisioning_strategy_get**](docs/ProvisioningStrategyApi.md#provisioning_strategy_get) | **GET** /provisioning-strategy/ | 
*OpenapiClient::ProvisioningStrategyApi* | [**provisioning_strategy_pk_delete**](docs/ProvisioningStrategyApi.md#provisioning_strategy_pk_delete) | **DELETE** /provisioning-strategy/{pk} | 
*OpenapiClient::ProvisioningStrategyApi* | [**provisioning_strategy_pk_get**](docs/ProvisioningStrategyApi.md#provisioning_strategy_pk_get) | **GET** /provisioning-strategy/{pk} | 
*OpenapiClient::ProvisioningStrategyApi* | [**provisioning_strategy_post**](docs/ProvisioningStrategyApi.md#provisioning_strategy_post) | **POST** /provisioning-strategy/ | 
*OpenapiClient::ServiceApi* | [**services_get**](docs/ServiceApi.md#services_get) | **GET** /services/ | 
*OpenapiClient::ServiceApi* | [**services_pk_delete**](docs/ServiceApi.md#services_pk_delete) | **DELETE** /services/{pk} | 
*OpenapiClient::ServiceApi* | [**services_pk_get**](docs/ServiceApi.md#services_pk_get) | **GET** /services/{pk} | 
*OpenapiClient::ServiceApi* | [**services_pk_put**](docs/ServiceApi.md#services_pk_put) | **PUT** /services/{pk} | 
*OpenapiClient::ServiceApi* | [**services_post**](docs/ServiceApi.md#services_post) | **POST** /services/ | 
*OpenapiClient::ServiceResourceAttachmentApi* | [**service_resource_attchment_get**](docs/ServiceResourceAttachmentApi.md#service_resource_attchment_get) | **GET** /service-resource-attchment/ | 
*OpenapiClient::ServiceResourceAttachmentApi* | [**service_resource_attchment_pk_delete**](docs/ServiceResourceAttachmentApi.md#service_resource_attchment_pk_delete) | **DELETE** /service-resource-attchment/{pk} | 
*OpenapiClient::ServiceResourceAttachmentApi* | [**service_resource_attchment_pk_get**](docs/ServiceResourceAttachmentApi.md#service_resource_attchment_pk_get) | **GET** /service-resource-attchment/{pk} | 
*OpenapiClient::ServiceResourceAttachmentApi* | [**service_resource_attchment_post**](docs/ServiceResourceAttachmentApi.md#service_resource_attchment_post) | **POST** /service-resource-attchment/ | 
*OpenapiClient::SnapshotApi* | [**snapshots_get**](docs/SnapshotApi.md#snapshots_get) | **GET** /snapshots/ | 
*OpenapiClient::SnapshotApi* | [**snapshots_pk_delete**](docs/SnapshotApi.md#snapshots_pk_delete) | **DELETE** /snapshots/{pk} | 
*OpenapiClient::SnapshotApi* | [**snapshots_pk_get**](docs/SnapshotApi.md#snapshots_pk_get) | **GET** /snapshots/{pk} | 
*OpenapiClient::SnapshotApi* | [**snapshots_post**](docs/SnapshotApi.md#snapshots_post) | **POST** /snapshots/ | 
*OpenapiClient::StorageHostApi* | [**storage_hosts_get**](docs/StorageHostApi.md#storage_hosts_get) | **GET** /storage-hosts | 
*OpenapiClient::StorageHostApi* | [**storage_hosts_pk_delete**](docs/StorageHostApi.md#storage_hosts_pk_delete) | **DELETE** /storage-hosts/{pk} | 
*OpenapiClient::StorageHostApi* | [**storage_hosts_pk_get**](docs/StorageHostApi.md#storage_hosts_pk_get) | **GET** /storage-hosts/{pk} | 
*OpenapiClient::StorageHostApi* | [**storage_hosts_post**](docs/StorageHostApi.md#storage_hosts_post) | **POST** /storage-hosts | 
*OpenapiClient::StorageResourceApi* | [**storage_resources_get**](docs/StorageResourceApi.md#storage_resources_get) | **GET** /storage-resources/ | 
*OpenapiClient::StorageResourceApi* | [**storage_resources_pk_delete**](docs/StorageResourceApi.md#storage_resources_pk_delete) | **DELETE** /storage-resources/{pk} | 
*OpenapiClient::StorageResourceApi* | [**storage_resources_pk_get**](docs/StorageResourceApi.md#storage_resources_pk_get) | **GET** /storage-resources/{pk} | 
*OpenapiClient::StorageResourceApi* | [**storage_resources_pk_put**](docs/StorageResourceApi.md#storage_resources_pk_put) | **PUT** /storage-resources/{pk} | 
*OpenapiClient::StorageResourceApi* | [**storage_resources_post**](docs/StorageResourceApi.md#storage_resources_post) | **POST** /storage-resources/ | 
*OpenapiClient::StorageSystemApi* | [**storage_systems_get**](docs/StorageSystemApi.md#storage_systems_get) | **GET** /storage-systems/ | 
*OpenapiClient::StorageSystemApi* | [**storage_systems_pk_delete**](docs/StorageSystemApi.md#storage_systems_pk_delete) | **DELETE** /storage-systems/{pk} | 
*OpenapiClient::StorageSystemApi* | [**storage_systems_pk_get**](docs/StorageSystemApi.md#storage_systems_pk_get) | **GET** /storage-systems/{pk} | 
*OpenapiClient::StorageSystemApi* | [**storage_systems_post**](docs/StorageSystemApi.md#storage_systems_post) | **POST** /storage-systems/ | 
*OpenapiClient::SystemTypeApi* | [**system_types_get**](docs/SystemTypeApi.md#system_types_get) | **GET** /system-types/ | 
*OpenapiClient::SystemTypeApi* | [**system_types_pk_delete**](docs/SystemTypeApi.md#system_types_pk_delete) | **DELETE** /system-types/{pk} | 
*OpenapiClient::SystemTypeApi* | [**system_types_pk_get**](docs/SystemTypeApi.md#system_types_pk_get) | **GET** /system-types/{pk} | 
*OpenapiClient::SystemTypeApi* | [**system_types_post**](docs/SystemTypeApi.md#system_types_post) | **POST** /system-types/ | 
*OpenapiClient::VolumeApi* | [**volumes_get**](docs/VolumeApi.md#volumes_get) | **GET** /volumes/ | 
*OpenapiClient::VolumeApi* | [**volumes_pk_delete**](docs/VolumeApi.md#volumes_pk_delete) | **DELETE** /volumes/{pk} | 
*OpenapiClient::VolumeApi* | [**volumes_pk_get**](docs/VolumeApi.md#volumes_pk_get) | **GET** /volumes/{pk} | 
*OpenapiClient::VolumeApi* | [**volumes_pk_put**](docs/VolumeApi.md#volumes_pk_put) | **PUT** /volumes/{pk} | 
*OpenapiClient::VolumeApi* | [**volumes_post**](docs/VolumeApi.md#volumes_post) | **POST** /volumes/ | 
*OpenapiClient::VolumeSafeDeleteApi* | [**safe_deletes_get**](docs/VolumeSafeDeleteApi.md#safe_deletes_get) | **GET** /safe-deletes/ | 
*OpenapiClient::VolumeSafeDeleteApi* | [**safe_deletes_pk_delete**](docs/VolumeSafeDeleteApi.md#safe_deletes_pk_delete) | **DELETE** /safe-deletes/{pk} | 
*OpenapiClient::VolumeSafeDeleteApi* | [**safe_deletes_pk_get**](docs/VolumeSafeDeleteApi.md#safe_deletes_pk_get) | **GET** /safe-deletes/{pk} | 
*OpenapiClient::VolumeSafeDeleteApi* | [**safe_deletes_post**](docs/VolumeSafeDeleteApi.md#safe_deletes_post) | **POST** /safe-deletes/ | 


## Documentation for Models

 - [OpenapiClient::AbstractCapability](docs/AbstractCapability.md)
 - [OpenapiClient::Account](docs/Account.md)
 - [OpenapiClient::AccountPostRequest](docs/AccountPostRequest.md)
 - [OpenapiClient::AccountPostResponse](docs/AccountPostResponse.md)
 - [OpenapiClient::Address](docs/Address.md)
 - [OpenapiClient::AddressCreate](docs/AddressCreate.md)
 - [OpenapiClient::AuthResponse](docs/AuthResponse.md)
 - [OpenapiClient::Authentication](docs/Authentication.md)
 - [OpenapiClient::AutoSDEProject](docs/AutoSDEProject.md)
 - [OpenapiClient::AutoSDERole](docs/AutoSDERole.md)
 - [OpenapiClient::CapabilityTranslation](docs/CapabilityTranslation.md)
 - [OpenapiClient::CapabilityTranslationCreate](docs/CapabilityTranslationCreate.md)
 - [OpenapiClient::Host](docs/Host.md)
 - [OpenapiClient::HostCreate](docs/HostCreate.md)
 - [OpenapiClient::HostVolumeConnection](docs/HostVolumeConnection.md)
 - [OpenapiClient::HostVolumeConnectionCreate](docs/HostVolumeConnectionCreate.md)
 - [OpenapiClient::Job](docs/Job.md)
 - [OpenapiClient::JobCreate](docs/JobCreate.md)
 - [OpenapiClient::NativeCapability](docs/NativeCapability.md)
 - [OpenapiClient::Profile](docs/Profile.md)
 - [OpenapiClient::ProvisioningStrategy](docs/ProvisioningStrategy.md)
 - [OpenapiClient::Service](docs/Service.md)
 - [OpenapiClient::ServiceAbstractCapabilityValue](docs/ServiceAbstractCapabilityValue.md)
 - [OpenapiClient::ServiceCreate](docs/ServiceCreate.md)
 - [OpenapiClient::ServiceResourceAttachment](docs/ServiceResourceAttachment.md)
 - [OpenapiClient::Snapshot](docs/Snapshot.md)
 - [OpenapiClient::SnapshotCreate](docs/SnapshotCreate.md)
 - [OpenapiClient::StorageHost](docs/StorageHost.md)
 - [OpenapiClient::StorageHostCreate](docs/StorageHostCreate.md)
 - [OpenapiClient::StorageHostResponse](docs/StorageHostResponse.md)
 - [OpenapiClient::StorageResource](docs/StorageResource.md)
 - [OpenapiClient::StorageResourceCreate](docs/StorageResourceCreate.md)
 - [OpenapiClient::StorageResourceResponse](docs/StorageResourceResponse.md)
 - [OpenapiClient::StorageSystem](docs/StorageSystem.md)
 - [OpenapiClient::StorageSystemCreate](docs/StorageSystemCreate.md)
 - [OpenapiClient::SystemType](docs/SystemType.md)
 - [OpenapiClient::SystemTypeCreate](docs/SystemTypeCreate.md)
 - [OpenapiClient::Volume](docs/Volume.md)
 - [OpenapiClient::VolumeCreate](docs/VolumeCreate.md)
 - [OpenapiClient::VolumeResponse](docs/VolumeResponse.md)
 - [OpenapiClient::VolumeSafeDelete](docs/VolumeSafeDelete.md)
 - [OpenapiClient::VolumeSafeDeleteCreate](docs/VolumeSafeDeleteCreate.md)
 - [OpenapiClient::VolumeUpdate](docs/VolumeUpdate.md)


## Documentation for Authorization


### bearerAuth

- **Type**: Bearer authentication

